script.on_event(
    defines.events.on_player_deconstructed_area,
    function(event)
        local box = event.area
        local player = game.players[event.player_index]
        local force = player.force
        local surface = player.surface
        local cliffs = surface.find_entities_filtered({area = box, type = "cliff"})

        for k, cliff in pairs(cliffs) do
            surface.create_entity(
                {
                    name = "entity-ghost",
                    expires = false,
                    force = force,
                    position = cliff.position,
                    inner_name = "cliff-explosive-proxy"
                }
            )
        end
    end
)

script.on_event(
    defines.events.on_robot_built_entity,
    function(event)
        local entity = event.created_entity
        if entity.name == "cliff-explosive-proxy" then
            game.players[1].surface.create_entity(
                {name = "cliff-explosives", target = entity, position = entity.position, speed = 100}
            )
            entity.destroy()
        end
    end
)

script.on_event(
    defines.events.on_built_entity,
    function(event)
        local entity = event.created_entity
        if entity.name == "cliff-explosive-proxy" then
            entity.destroy()
            local player = game.players[event.player_index]
            player.insert({name = "cliff-explosives", count = 1})
        end
    end
)
